global function ClGamemodeTTDM_Init

void function ClGamemodeTTDM_Init()
{
	AddCallback_GameStateEnter( eGameState.Postmatch, DisplayPostMatchTop3 )

	AddCallback_OnClientScriptInit( TTDM_OverrideMinimapPackages )

	// Minimap_SetZoomScale( 3.0 )
	// Minimap_SetSizeScale( 1.5 )
}

void function TTDM_OverrideMinimapPackages( entity player )
{
	printt("TTDM_OverrideMinimapPackages")
	RegisterMinimapPackage("player", 0, $"ui/minimap_object.rpak", MinimapPackage_PlayerInit)
}

void function MinimapPackage_PlayerInit( entity ent, var rui )
{
	printt("MinimapPackage_PlayerInit")




	RuiTrackGameTime( rui, "lastFireTime", ent, RUI_TRACK_LAST_FIRED_TIME )
	if ( !IsFFAGame() ) //JFS: Too much work to get FFA to work correctly with Minimap logic, so disabling it for FFA
	{
		RuiTrackFloat( rui, "sonarDetectedFrac", ent, RUI_TRACK_STATUS_EFFECT_SEVERITY, eStatusEffect.sonar_detected )
	}

	// RuiSetBool( rui, "alwaysShowOnMinimap", true )


	entity titan = GetSoulFromPlayer(ent).GetTitan()
	asset titanIcon = GetIconFromTitanCharacterName(GetTitanCharacterName(titan))
	printt(titanIcon)
	RuiSetImage( rui, "defaultIcon", titanIcon )
	RuiSetImage( rui, "clampedDefaultIcon", titanIcon )
	RuiSetBool( rui, "overrideTitanIcon", true )
}

asset function GetIconFromTitanCharacterName(string name) {
	switch (name) {
		case "ion":
			return $"rui/hud/gametype_icons/fd/fd_icon_ion"
		case "tone":
			return $"rui/hud/gametype_icons/fd/fd_icon_tone"
		case "scorch":
			return $"rui/hud/gametype_icons/fd/fd_icon_scorch"
		case "legion":
			return $"rui/hud/gametype_icons/fd/fd_icon_legion"
		case "ronin":
			return $"rui/hud/gametype_icons/fd/fd_icon_ronin"
		case "northstar":
			return $"rui/hud/gametype_icons/fd/fd_icon_northstar"
		case "vanguard":
			return $"rui/hud/gametype_icons/fd/fd_icon_monarch"
	}
	return $""
}
